#pragma hdrstop
#include <condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include "dxsoftex.h"


//---------------------------------------------------------------------------
USELIB("dxsoftex.lib");
//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char **argv)
{
 int rxsym,txsym,canal_num=1,idle;

 // Use canal_num=1 for TrueTTY
 if(argc>1) canal_num=atoi(argv[1]);
 if(!DxsoftExchangeInit(canal_num))
      {
       printf("Initialization failed! \n");
       return 1;
      }


 while(1)
   {
    idle=1;
    rxsym=DxsoftGetSymFromRxBuffer();
    if(rxsym != -1)
      {
       // we have received symbol
       textcolor(YELLOW);
       putch(rxsym); // we need CharToOem() there for 8-bit symbols
       idle=0;
      }

    if(kbhit())
     {
      // key pressed
      txsym=getch();
      if(txsym==27) break; //Escape pressed, exit ...
      if(DxsoftPutSymToTxBuffer((char)txsym))
       {
        // we have transferred symbol to tx buffer
        textcolor(WHITE);
        putch(txsym); // we need OemToChar() there for 8-bit symbols
       }
      if(txsym=='\r')
       {
        // add LF to CR
          if(DxsoftPutSymToTxBuffer('\n'))
           {
            // we have transferred symbol to tx buffer
            textcolor(WHITE);
            putch('\n');
           }
       }
      idle=0;
     }
    if (idle) Sleep(100);
   }

  textcolor(LIGHTGRAY);
  putch('\r');putch('\n');
  return 0;
}
